# be careful. MS Dos truncates some names, such as initialize.c

CXX=g++ -pipe
CXXFLAGS= -DDEBUG -g -Wshadow -Wall -pedantic	
OBEX=.o
PARSFILE=rayparse.tab
LINKER=g++
YFLAGS=-d -y
YACC=bison
LOADLIBES=-lm 

##

include Sources.make

default_target:
	$(MAKE) -C .. rayce

# the basic rule
rayce: $(PARSFILE).cc $(OBJ)  #stupid trick to make .hh file
	$(LINKER) $(LDFLAGS) -o rayce $(OBJ) $(LOADLIBES)

dummy:

progdoc:
	doc++ -I -d ../doc++ -p $(MYSRC) $(MYHDR)

include depend

# speed version of rayce
srayce: dummy
	$(MAKE) CXXFLAGS='-c -O2  -fomit-frame-pointer -finline-functions -funroll-loops' rayce
	mv rayce srayce

# rebuild for debugging.
debug:
	$(MAKE) CXXFLAGS='-DDEBUG -c -g -Wall' rayce

# for profiling. 
prayce: $(SRC)
	$(MAKE) LDFLAGS='-pg' CXXFLAGS='-O2 -c -pg -finline-functions -funroll-loops' rayce
	mv rayce prayce

depend: Sources.make
	gcc -MM $(SRC) |sed 's/proto.hh//g'> depend

TAGS: $(SRC) $(HDR)
	etags -CT  $(MYSRC) *.y $(MYHDR)


clean:
	-rm -f *.u *.o  core.* *~ \#* gmon.out rayparse.output

$(PARSFILE).hh: rayparse.y
	-rm $(PARSFILE).cc
	make $(PARSFILE).cc

$(PARSFILE).cc: rayparse.y
	$(YACC) $(YFLAGS) rayparse.y
	-mv y.tab.c $(PARSFILE).c		# move any Yacc output to right files.
	-mv $(PARSFILE).c $(PARSFILE).cc		# move any Yacc output to right files. 
	-mv y.tab.h $(PARSFILE).hh
	

genclean:
	-rm -f $(PARSFILE).cc $(PARSFILE).hh


DFILES=$(MYSRC) $(MYHDR) stub.cc rayparse.y Sources.make
dist:
	mkdir $(LDISTDIR)/src
	ln  $(DFILES) $(LDISTDIR)/src
