/*
   Just an idea.

   A lamp on a table, demonstrating falloff of light.

   1993 HWN
*/

// in centimeters
#include "standard.inc"
#include "shapes.inc"
#include "colors.inc"
#include "textures.inc"


camera {
    location <-130, 200, -200>
    sky y
    fov 45
    look_at <30, 130, 0>
}

#define Cream = color rgb <0.9, 1.0, 1.0>

#define Wall_Text = texture {
    finish {
        diffuse color Cream diffuse 0.8
        ambient color Cream ambient 0.2
    }
}

#define Porcelain = texture {
    finish {
        specular color Turquoise
        ambient color rgb <0.5>
        diffuse color rgb <0.1>
        microfacet Blinn
        angle 10
    }
}


#define Wood_Texture = texture {
    finish {
        diffuse color Brown diffuse 0.45
        ambient color Brown ambient 0.05
    }
}

#define  wall = object {
    plane { -z, 0 }
    texture {
        Wall_Text
    }
}

#define leg = box { <-4, 0, -4>, <4, 100, 4> }

#define table = composite {
    object { leg translate <-70, 0,  75> }
    object { leg translate < 70, 0, -75> }
    object { leg translate <-70, 0, -75> }
    object { leg translate < 70, 0,  75> }
    box { <-80, 100, -80>, <80, 110, 80> }
    texture { Wood_Texture }
}

#define cap = object {
    object { QCone_Y }
    bounded_by  { box { <-100, -20, -100>, <100, -40, 100> } }
    clipped_by { bounded_by }
    translate 40*y
    texture  {finish {
            ambient color rgb 0.7 * <color CornflowerBlue>
            diffuse color rgb 0.3 * <color CornflowerBlue>
        }
    }
}

#define stand = composite {
    cylinder { <0>, <0, 32, 0>, 3 }
    cylinder { <0>, 3 * y,  15 }
    torus { 15, 1.5 translate 1.5*y }
    light_source {
        y*45 color rgb 10*<color Yellow>
        radius 4 attenuation 1
    }
    texture { Brass_Metal }
}

#define lamp = composite {
    object {
        stand
    }
    object { cap translate y*30 }
}

#define plate = composite {
    intersection {
        cone { <0>,  y, 20, 30  }
        cone { 0.1*y, 1.1*y, 20, 30  inverse }
        texture {
            pigment {
                color ForestGreen
            }
            finish {
                
                specular color rgb <1>
                ambient 0.5
                diffuse 0.1 //1
                microfacet Blinn
                angle 10
            }
        }
    }
    cylinder { <0>, 1.1 * y, 20  texture { Porcelain } }
}

#define pencil =
composite{
    intersection {
	cone { <0>, 2*x, 0, 0.5 texture { Wood_Texture } }
	object { Hexagon scale <8, 0.4, 0.4> translate 8*x texture { pigment {color Yellow } } }
    }	

    object {
	Hexagon scale <8, 0.4, 0.4> translate 8*x
	    texture { pigment {color Yellow } }
    }
    translate 0.4*y
}

#define wineglass = composite {
    intersection {
        object { Paraboloid_Y scale <1, 0.5, 1> translate 0.5*y }
        object { Paraboloid_Y scale <1, 0.5, 1> inverse }
        scale <2, 1, 2>
        box { <-7, 0, -7>, <7> }
        translate 7*y
    }
    cylinder { <0>, 7.0*y,  .5 }
    cylinder { <0>, 0.5*y,  3 }
    texture { Glass }
}

/**********************/
object { table translate z*-60  }
object { wall }

//object { light_source { <-200, 200, -200> color rgb <0.2> } }

composite { // stuff on table
    object { plate translate <-50, 0, -70> }
    object { lamp translate <0, 0, -60> }
    object { wineglass translate <-30,  0, -100> }
    object { pencil rotate y*45 translate <1, 0, -90> }
    translate <0, 110, 0>
}











