/*
   This scene is (c) 1995 Han-Kwang Nienhuys

   Distributed under terms of the GPL.
*/
/* A ROOM

dimensions in mm

Room is box <0>, <4000,2500,4000>
Window on z=4000

Needs standard.inc

*/


#declare walltexture = texture { finish {
    ambient color rgb <0.15, 0.15, 0.1>
    diffuse color rgb <0.5, 0.5, 0.4>
    roughness 0
}}

#declare floortexture = texture { finish {
    ambient color rgb <0.2, 0.1, 0>
    diffuse color rgb <0.6, 0.3, 0>
    reflection color rgb <0.05, 0.05, 0.05>
    roughness 0
}}

#declare ceiltexture = texture { finish {
    ambient color rgb <0.2, 0.2, 0.2>
    diffuse color rgb <0.8, 0.8, 0.8>
    roughness 0
}
}
#declare doortexture = texture { floortexture }

#declare furntexture1 = texture { finish {
    ambient color rgb <0.06, 0.015, 0>
    diffuse color rgb <0.25, 0.07, 0>
    reflection color rgb <0.1, 0.1, 0.1>
    reflect_angle 0.3
    microfacet Phong
    angle 0.5
}
}
#declare windowtexture = texture { finish {
    ambient color rgb <1, 1, 1>
}
}
#declare curttexture = texture { finish {
    diffuse color rgb <0.4, 0.13, 0>
    ambient color rgb <0.15, 0.05, 0>
    roughness 0
}
}
#declare lamptexture = texture { finish {
    ambient color rgb <1, 1, 0.6>
}
}

#declare desk = composite {
    box { <0>, <350, 800, 700> }
    box { <0>, <350, 800, 700> translate x*1150 }
    box { <350, 650, 0>, <1150, 800, 700> }
    texture { furntexture1 }
}

#declare couch = composite {
    box{ <0>, <150, 600, 1300> rotate z*30 }
    box { <0>, <600, 150, 1300> rotate z*10 }
    translate <300, 250, 0>
    texture { furntexture1 }
}

#declare bookcase = composite {
    polygon { <0>, <350, 0, 0>, <350, 0, 2250>, <0, 0, 2250> translate 1600*y }
    polygon { <0>, <350, 0, 0>, <350, 0, 2250>, <0, 0, 2250> translate 950*y }
    polygon { <0>, <350, 0, 0>, <350, 0, 2250>, <0, 0, 2250> translate 1275*y }
    polygon { <0>, <350, 0, 0>, <350, 650, 0>, <0, 650, 0> translate y*950 }
    polygon { <0>, <350, 0, 0>, <350, 650, 0>, <0, 650, 0> translate <0, 950, 1000> }
    polygon { <0>, <350, 0, 0>, <350, 1600, 0>, <0, 1600, 0> translate z*1500 }
    polygon { <0>, <350, 0, 0>, <350, 1600, 0>, <0, 1600, 0> translate z*2250 }
    polygon { <0>, <0, 0, 750>, <0, 160, 750>, <0, 160, 0> translate z*1500 }
    texture { furntexture1 }
}

#declare bookcase2 = composite {
    box { <0>, <3000, 2200, 400> texture {furntexture1 } }
    polygon {<10, 0, 401>,< 10, 350, 401>,< 900, 350, 401>, <900, 0, 401>
	texture { pigment { color Black }} translate y* 400 }
    polygon {<10, 0, 401>,< 10, 350, 401>,< 900, 350, 401>, <900, 0, 401> texture { pigment { color Black }} translate y*800 }
    polygon {<10, 0, 401>,< 10, 350, 401>,< 900, 350, 401>, <900, 0, 401> texture { pigment { color Grey30 }} translate y*1200 }
    polygon {<10, 0, 401>,< 10, 350, 401>,< 900, 350, 401>, <900, 0, 401> texture { pigment { color Grey30 }} translate y*1600 }
    polygon {<10, 0, 401>,< 10, 350, 401>,< 900, 350, 401>, <900, 0, 401> texture { pigment { color rgb <0, 0.3, 0.1> }} translate <1000, 400, 0> }
    polygon {<10, 0, 401>,< 10, 350, 401>,< 900, 350, 401>, <900, 0, 401> texture { pigment { color rgb <0, 0.1, 0.3> }} translate <1000, 800, 0> }
    polygon {<10, 0, 401>,< 10, 350, 401>,< 900, 350, 401>, <900, 0, 401> texture { pigment { color Grey30 }} translate <1000, 1200, 0> }
    polygon {<10, 0, 401>,< 10, 350, 401>,< 900, 350, 401>, <900, 0, 401> texture { pigment { color rgb <0.3, 0.1, 0> }} translate <1000, 1600, 0> }
    polygon {<10, 0, 401>,< 10, 350, 401>,< 900, 350, 401>, <900, 0, 401> texture { pigment { color rgb <0.1, 0.1, 0.1> }} translate <2000, 400, 0> }
    polygon {<10, 0, 401>,< 10, 350, 401>,< 900, 350, 401>, <900, 0, 401> texture { pigment { color rgb <0.1, 0.1, 0.1> }} translate <2000, 800, 0> }
    polygon {<10, 0, 401>,< 10, 350, 401>,< 900, 350, 401>, <900, 0, 401> texture { pigment { color rgb <0, 0.3, 0.1> } }translate <2000, 1200, 0> }
    polygon {<10, 0, 401>,< 10, 350, 401>,< 900, 350, 401>, <900, 0, 401> texture { pigment { color Grey30 }} translate <2000, 1600, 0> }
}

#declare room = composite {
// the walls    
    composite {
        polygon { <0>, <0, 0, 4000>, <0, 2500, 4000>, <0, 2500, 0> } // east
        polygon { <0>, <0, 0, 4000>, <0, 2500, 4000>, <0, 2500, 0> rotate y*90 } //north
        polygon { <0>, <0, 0, 4000>, <0, 2500, 4000>, <0, 2500, 0> translate x*4000 } //west
        polygon { <0>, <0, 0, 4000>, <0, 2500, 4000>, <0, 2500, 0> rotate y*90 translate z*4000 } // south
        texture { walltexture }
    }
    polygon { <0>, <4000, 0, 0>, <4000, 0, 4000>, <0, 0, 4000> texture {floortexture } } // floor
    polygon { <0>, <4000, 0, 0>, <4000, 0, 4000>, <0, 0, 4000> translate y*2500 texture {ceiltexture } } // ceiling
    polygon { <0>, <0, 2000, 0>, <0, 2000, 800>, <0, 0, 800> translate <3999, 0, 2800> texture {doortexture } } //door 1
    
    composite { // window
        polygon { <1500, 800, 0>, <2500, 800, 0>, <2500, 1800, 0>, <1500, 1800, 0> }
        polygon { <1500, 1950, 0>, <2500, 1950, 0>, <2500, 2280, 0>, <1500, 2280, 0> }
        translate z*3999 texture {windowtexture }
    }
    light_source { <2000, 1500, 3998> radius 500 } // light from window
    polygon { <0, 800, 0>,< 300, 800, 0>,< 300, 2500, 0>,< 0, 2500, 0> texture { curttexture } translate <2500, 0, 3900> }
    polygon { <0, 800, 0>,< 300, 800, 0>,< 300, 2500, 0>,< 0, 2500, 0> texture { curttexture } translate <1200, 0, 3900> }
    
    object { desk translate <1250, 0, 3000> }
    
    object { cylinder { <0>, 200*y, 200 translate <2000, 2300, 2000> texture {lamptexture } } no_shadow } // lamp
    light_source { <2000, 2400, 2000> color rgb <1, 1, 0.6>  }
    
    object { bookcase translate <1, 700, 1749> }
    object { couch translate z*1100 }
    object { desk rotate y*90 translate <3100, 0, 2700> }
    
    polygon { <100, 0, 1>, <100, 2000, 1>, <900, 2000, 1>, <900, 0, 1> texture {doortexture } }
    
    object { bookcase2 translate x*1000 }
}


