/* -*-c++-*-
   eye viewing stuff */
#ifndef CAMERA_H

#include "vector.hh"

class Camera
{
    flt     fov;
public:
    vector  eye_dir,
            eye,
            sky,
            up,
            right;

    flt aspect;

    void 	set_fov_angle(flt angle);

    /* point the camera towards a particular point. */
    void point(vector lookat);
    void set_eyeray(ray & r, flt & filter, int curx, int cury, int xres, int yres);
    Camera();
    void precompute();
    void translate(const vector t);
    void rotate(const matrix & rotmat);
    void scale(const vector s);
    void print() const ;
};

#define CAMERA_H
#endif
