// VIRTUALS for Base Classes, some other things


#include "matrix.hh"
#include "object.hh"
#include "extern.hh"
#include "shapes.hh"
#include "proto.hh"
#include "ibuf.hh"
#include "matrix.hh"

/****************************************************************
  SHAPE_DATA
 ****************************************************************/

vector shape_data::normal(vector) const
{
    errormsg("normal not def'd");
    return 0.0;
}

bool shape_data::inside(vector) const
{
    errormsg("inside undef'd");
    return false;
}

void
shape_data::rotate(matrix const &)
{
    assert(false);
}

void
shape_data::add_speed(vector )
{
    assert(false);
}

void
shape_data::scale(vector )
{
    assert(false);
}

void
shape_data::translate(vector)
{
    assert(false);
}

/* scale the ((XXXX_data *) shape_data->data) with transform matrices */
void
shape_data::print() const
{
    #ifdef DEBUG
    dprintf("type %d\n", type);
    #endif
}

int shape_data::do_intersection(ray *, flt *, int) const
{
    errormsg("no intersection method");
    return 0;
}

bool shape_data::all_intersections(ibuf * q, ray * r, int flags, bool &isinside) const
{
    flt     inter[100];
    bool    loc_ins = false;

    getstatp()->test++;    
    int    n = do_intersection(r, inter,flags);

    assert(n>=0);

    if (flags & CHKINSIDE)
    {
	assert(daddy->flags & O_CLOSED);
	
        if (!(daddy->flags & O_INFINITE) )
            loc_ins = (n % 2);
        else {
            /* not closed, then use brute force */
            vector      sample = r->point(2 * tolerance); // waarom 2?
	    loc_ins = inside(sample);
        }
    }

    
    loc_ins ^= bool(daddy->flags & O_INVERTED);
    isinside= loc_ins;

    if (!n)
        return false;
    if (!(flags & CHKALL))     /* check everything? */    
      n = 1;

    getstatp()->hit++;
    dqueue  q_ent;
    for (int j = 0; j < n; j++)
        {
            q_ent.t = inter[j];
            q_ent.obj = daddy;
            q_ent.entering = (loc_ins = !loc_ins);
            q->add_to(flags, q_ent);
    }
    return true;
}

void
shape_data::add_child(object *)
{
    assert(false);
}

void
shape_data::bound(matrix *, bounding_box *) {

}

void
shape_data::add_children_to_optilist(Optilist *) {

}

shape_data::~shape_data() {
    
}

void
shape_data::setdaddy(object const *bla) {
    daddy = (object *)bla;
}

shape_data::shape_data()
{
    type = NOSHAPE;
    refcount = 0;
    daddy = 0;
}


long    shape_data::prims,
        shape_data::nonprims;
/****************************************************************/
	// UGLY! should rethink place /deps of transformd 
vector
object::transformd(const vector & x) const
{
    if (tranp.inv_trans)
    {
        matrix & A = *tranp.inv_trans;
        return vector(A[0][0] * x.x + A[0][1] * x.y + A[0][2] * x.z,
		      A[1][0] * x.x + A[1][1] * x.y + A[1][2] * x.z,
		      A[2][0] * x.x + A[2][1] * x.y + A[2][2] * x.z);
    }
    return x;
}

vector
object::transformx(const vector & x) const
{
    if (tranp.inv_trans)
        return *tranp.inv_trans * x;
    return x;
}

vector
object::transformn(const vector & n)const
{
    if (tranp.inv_trans)
    {
        matrix & A = *tranp.inv_trans;
        return vector(n.x * A[0][0] + n.y * A[1][0] + n.z * A[2][0],
		      n.x * A[0][1] + n.y * A[1][1] + n.z * A[2][1],
		      n.x * A[0][2] + n.y *A[1][2] + n.z * A[2][2]);
    }

    return n;
}

void
object::transformr(ray & n) const
{
    n.dir = transformd(n.dir);
    n.pos = transformx(n.pos);
}

/****************************************************************
  TRANSFORMATION PAIRS
 ****************************************************************/


transpair::transpair()
{
    trans = inv_trans = 0;
}

// whoops! don't use this in a constructor
void
transpair::allocself()
{
    if (!trans)
        trans = new matrix(1);
    if (!inv_trans)
        inv_trans = new matrix(1);
}



transpair::transpair(transpair & src)
{
  trans =  (src.trans) ? new matrix(*src.trans):0;
  inv_trans =  (src.inv_trans) ? new matrix(*src.inv_trans) :0;
}

void
transpair::precompute()
{
    delete  trans;
}

transpair::~transpair()
{
    delete  trans;
    delete  inv_trans;
}


void
transpair::print() const
{
#ifdef DEBUG
    if (inv_trans)
    {
        dprintf("Inverse Transformation\n");
        (*inv_trans).print();
    }
#endif
}

void
transpair::scale(const vector s)
{
    matrix  m;
    allocself();
    m.inv_scale(s);
    *inv_trans = (*inv_trans) * m;
    m.scale(s);
    *trans = m * (*trans);
}

void
transpair::translate(const vector t)
{
    matrix  m;
    allocself();
    m.inv_translate(t);
    *inv_trans = (*inv_trans) * m;
    m.translate(t);
    *trans = m * (*trans);
}

/* rotate the ((XXXX_data *) transpair->data) with transform matrices */
void
transpair::rotate(const matrix & m)
{
    allocself();
    *trans = m * (*trans);
    *inv_trans = *inv_trans * m.transpose();
}




